;
;   This is the screen update procedure.  Actually, it is more like
;   a `blit' procedure, but assuming everything is 16-bit-aligned.
;
;   Also a ClearMemQuick() to supply something C= didn't think of.
;
	public	_updaterect
	public	_ClearMemQuick
;
;   Inputs:
;
;      Source pointer
;      Source width (modulo)
;      Destination pointer
;      Destination width (modulo)
;      Block width (in bytes)
;      Block height
;
;   First, we have the section of code that does major block moves.
;   Each set of three instructions does 48 bytes.
;
dobigbig:
	move.l	4(a7),0(a7)
bbloop:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
	sub.l	#1,0(a7)
	bne	bbloop
	jmp	(a2)
do20big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do19big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do18big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do17big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do16big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do15big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do14big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do13big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do12big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do11big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do10big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do9big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do8big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do7big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do6big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do5big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do4big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do3big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do2big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
do1big:
	movem.l	(a0)+,d0-d7/a3-a6
	movem.l	d0-d7/a3-a6,(a1)
	add.w	#48,a1
	jmp	(a2)
do46small:
	move.w	(a0)+,(a1)+
do44small:
	movem.l	(a0)+,d0-d7/a3-a5
	movem.l	d0-d7/a3-a5,(a1)
	add.w	#44,a1
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do42small:
	move.w	(a0)+,(a1)+
do40small:
	movem.l	(a0)+,d0-d7/a3-a4
	movem.l	d0-d7/a3-a4,(a1)
	add.w	#40,a1
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do38small:
	move.w	(a0)+,(a1)+
do36small:
	movem.l	(a0)+,d0-d7/a3
	movem.l	d0-d7/a3,(a1)
	add.w	#36,a1
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do34small:
	move.w	(a0)+,(a1)+
do32small:
	movem.l	(a0)+,d0-d7
	movem.l	d0-d7,(a1)
	add.w	#32,a1
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do30small:
	move.w	(a0)+,(a1)+
do28small:
	movem.l	(a0)+,d0-d6
	movem.l	d0-d6,(a1)
	add.w	#28,a1
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do26small:
	move.w	(a0)+,(a1)+
do24small:
	movem.l	(a0)+,d0-d5
	movem.l	d0-d5,(a1)
	add.w	#24,a1
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do22small:
	move.w	(a0)+,(a1)+
do20small:
	movem.l	(a0)+,d0-d4
	movem.l	d0-d4,(a1)
	add.w	#20,a1
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do18small:
	move.w	(a0)+,(a1)+
do16small:
	movem.l	(a0)+,d0-d3
	movem.l	d0-d3,(a1)
	add.w	#16,a1
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do14small:
	move.w	(a0)+,(a1)+
do12small:
	movem.l	(a0)+,d0-d2
	movem.l	d0-d2,(a1)
	add.w	#12,a1
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do10small:
	move.w	(a0)+,(a1)+
do8small:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do6small:
	move.w	(a0)+,(a1)+
do4small:
	move.l	(a0)+,(a1)+
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
do2small:
	move.w	(a0)+,(a1)+
do0small:
	add.l	8(a7),a0
	add.l	12(a7),a1
	sub.l	#1,16(a7)
	beq	out
	move.l	20(a7),a4
	jmp	(a4)
bigtab:
	dc.l	0,do1big,do2big,do3big,do4big,do5big,do6big,do7big,do8big,do9big
	dc.l	do10big,do11big,do12big,do13big,do14big,do15big,do16big,do17big
	dc.l	do18big,do19big,do20big
smtab:
	dc.l	do0small,do2small,do4small,do6small,do8small,do10small
	dc.l	do12small,do14small,do16small,do18small,do20small,do22small
	dc.l	do24small,do26small,do28small,do30small,do32small,do34small
	dc.l	do36small,do38small,do40small,do42small,do44small,do46small
_updaterect:
	movem.l	d1-d7/a0-a6,-(a7)
	sub.w	#24,a7
;
;   We use the following scheme.
;
;   For any amounts not divisible by 48, we use a single call of a routine
;   indexed by smtab per line.
;
;   For amounts from 48 to 20 * 48 (960), we use a single call of a routine
;   indexed by bigtab per line.  Note that that is 7680 pixels.  If the
;   user uses a screen wider than this, then he suffers.
;
;   For amounts greater than or equal to 1008, we use a simple loop that
;   does 48 at a time.
;
;   At this point the stack looks like this:
;
;   0(a7):    counter for very large copies
;   4(a7):    size for very large copies
;   8(a7):    source increment
;   12(a7):   destination increment
;   16(a7):   height counter
;   20(a7):   address to use for long ones
;
;   24(a7):   14 long registers saved
;
;   80(a7):   return address
;
;   84(a7):   source pointer
;   88(a7):   source width
;   92(a7):   destination pointer
;   96(a7):   destination width
;   100(a7):  block width
;   104(a7):  block height
;
	move.l	104(a7),16(a7)
	move.l	100(a7),d0
	move.l	96(a7),d1
	sub.l	d0,d1
	move.l	d1,12(a7)
	move.l	88(a7),d1
	sub.l	d0,d1
	move.l	d1,8(a7)
	move.l	84(a7),a0
	move.l	92(a7),a1
	divu	#48,d0
	swap	d0
	add.w	d0,d0
	lea.l	smtab(pc),a4
	move.l	(a4,d0.w),a2
	move.l	a2,20(a7)
	swap	d0
	ext.l	d0
	beq	over1
	move.l	d0,4(a7)
	cmp.w	#20,d0
	bcs	over2
	move.l	#20,d0
over2:
	add.l	d0,d0
	add.l	d0,d0
	lea.l	bigtab(pc),a4
	move.l	(a4,d0.l),20(a7)
over1:
	move.l	20(a7),a4
	jmp	(a4)
out:
	add.w	#24,a7
	movem.l	(a7)+,d1-d7/a0-a6
	move.l	#0,d0
	rts
;
;   Our memory clear routine.
;
;   a0:  address to clear
;   d0:  number of bytes to clear
;
;   64(a7):  length to clear
;   60(a7):  where to clear
;
;   56(a7):  return address
;
;   0(a7):  14 registers
;
_ClearMemQuick:
	movem.l	d1-d7/a0-a6,-(a7)
	move.l	#0,d1
	move.l	#0,d2
	move.l	#0,d3
	move.l	#0,d4
	move.l	#0,d5
	move.l	#0,d6
	move.l	#0,d7
	move.l	d1,a1
	move.l	d1,a2
	move.l	d1,a3
	move.l	d1,a4
	move.l	d1,a5
	move.l	d1,a6
	move.l	60(a7),a0
	move.l	64(a7),d0
	divu	#52,d0
	dbra	d0,bloop
	bra	ovc1
bloop:
	movem.l	d1-d7/a1-a6,(a0)
	add.w	#52,a0
bloopin:
	dbra	d0,bloop
ovc1:
	swap	d0
	ext.l	d0
	add.l	d0,d0
	lea	cmqtab(pc),a2
	move.l	(a2,d0.l),a2
	move.l	#0,d0
	jmp	(a2)
cmqtab:
	dc.l	cmq0,cmq2,cmq4,cmq6,cmq8,cmq10,cmq12,cmq14,cmq16,cmq18,cmq20
	dc.l	cmq22,cmq24,cmq26,cmq28,cmq30,cmq32,cmq34,cmq36,cmq38,cmq40
	dc.l	cmq42,cmq44,cmq46,cmq48,cmq50
cmq50:
	move.w	#0,(a0)+
cmq48:
	movem.l	d0-d7/a3-a6,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq46:
	move.w	#0,(a0)+
cmq44:
	movem.l	d0-d7/a3-a5,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq42:
	move.w	#0,(a0)+
cmq40:
	movem.l	d0-d7/a3-a4,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq38:
	move.w	#0,(a0)+
cmq36:
	movem.l	d0-d7/a3,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq34:
	move.w	#0,(a0)+
cmq32:
	movem.l	d0-d7,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq30:
	move.w	#0,(a0)+
cmq28:
	movem.l	d0-d6,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq26:
	move.w	#0,(a0)+
cmq24:
	movem.l	d0-d5,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq22:
	move.w	#0,(a0)+
cmq20:
	movem.l	d0-d4,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq18:
	move.w	#0,(a0)+
cmq16:
	movem.l	d0-d3,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq14:
	move.w	#0,(a0)+
cmq12:
	movem.l	d0-d2,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq10:
	move.w	#0,(a0)+
cmq8:
	movem.l	d0/d1,(a0)
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq6:
	move.w	#0,(a0)+
cmq4:
	move.l	#0,(a0)+
	movem.l	(a7)+,d1-d7/a0-a6
	rts
cmq2:
	move.w	#0,(a0)+
cmq0:
	movem.l	(a7)+,d1-d7/a0-a6
	rts
